// Demo 4: Square.java
//
//       A Square Demo
//   A Simple Java Square Class
//
//       by Charles W. Neville
//   Copyright Charles W. Neville, June 1999
//
//  Some of you may have read the mathematical classic 
//  "Flatland" by A. Square.  Here is A Square Demo, in 
//  the great tradition of A. Square himself
//
//  Class Square is designed to be used by other classes.
//
//  A Square object should know
//    1. Its position (x and y cooordinates -- state variables).
//    2. Its size (state variable).
//    3. Its color (state variable).
//    4. How to set its position (set methods).
//    5. How to report its position (get methods).
//    6. How to set its size (set method).
//    7  How to report its size (get method).
//    8. How to set its color (set method).
//    9. How to report its color (get method).
//   10. How to expand its size (method).
//   11. How to move itself (method).
//   12. How to draw itself (methods).

// Note: Same as the CS 151 Demo of the same name.

import java.awt.*;

public class Square {

  private int x, y;    // x, y position coordinates
  private int size;    // width and height
  private Color color; // our color, of course

  // A Square Constructor -- the "s" stands for "square"
  //   Like most constructors, this one simply initializes
  //   our object state variables.
  public Square(int sx, int sy, int ssize, 
                Color scolor) {

      x = sx;
      y = sy;
      size = ssize;
      color = scolor;
  }

  // set our x coordinate
  public void setX(int sx) {

     x = sx;
  }

  // return our x coordinate
  public int getX() {

     return x;
  }

  // set our y coordinate
  public void setY(int sy) {

     y = sy;
  }

  // return our y coordinate
  public int getY() {

     return y;
  }

  // set our size
  public void setSize(int ssize) {

     size = ssize;
  }

  // return our size
  public int getSize() {

     return size;
  }

  // set our color
  public void setColor(Color scolor) {

     color = scolor;
  }

  // return our color
  public Color getColor(Color scolor) {

     return color;
  }

  // expand our size by s pixels
  public void expand(int s) {


     size = size + s;
  }

  // move r pixels to the right and s pixels down
  public void move(int r, int s) {

     x = x + r;
     y = y + s;
  }
   
  // draw ourself in our natural color
  public void draw(Graphics g) {

     Color currColor;

     currColor = g.getColor();  // get current drawing
                                // color
     g.setColor(color);
     g.fillRect(x, y, size, size);

     g.setColor(currColor);  // set drawing color back
  }

  // draw ourself in a given color
  public void draw(Graphics g, Color scolor) {

     Color currColor;

     currColor = g.getColor();
     g.setColor(scolor);
     g.fillRect(x, y, size, size);

     g.setColor(currColor);
  }

} // class Square